Index: loneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/gsm_edit_pinging.cpy
===================================================================
--- /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/gsm_edit_pinging.cpy	(revision 419)
+++ 	(revision )
@@ -1,20 +1,0 @@
-## Script (Python) "gsm_edit_pinging"
-##bind container=container
-##bind context=context
-##bind namespace=
-##bind script=script
-##bind subpath=traverse_subpath
-##parameters=transitions=[]
-##title=Configure Plone Google Sitemap
-##
-
-from Products.qPloneGoogleSitemaps.utils import setWorkflowTransitions
-from Products.CMFCore.utils import getToolByName
-
-if not transitions:
-    w_tool = getToolByName(context, "portal_workflow")
-    transitions = [w + "#" for w in w_tool.listWorkflows()]
-
-setWorkflowTransitions(context, transitions)
-
-return state.set(portal_status_message = "Plone Google Sitemap updated.")
Index: loneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/gsm_edit_pinging.cpy.metadata
===================================================================
--- /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/gsm_edit_pinging.cpy.metadata	(revision 419)
+++ 	(revision )
@@ -1,14 +1,0 @@
-#
-# $$
-#
-[default]
-title= Save Propertiest
-
-[security]
-View=0:Authenticated
-
-[validators]
-
-[actions]
-action.success=traverse_to:string:prefs_gsm_pinging
-action.failure=traverse_to:string:prefs_gsm_pinging
Index: loneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/ping_googlesitemaps.cpy
===================================================================
--- /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/ping_googlesitemaps.cpy	(revision 419)
+++ 	(revision )
@@ -1,23 +1,0 @@
-## Script (Python) "ping_googlesitemaps.cpy"
-##bind container=container
-##bind context=context
-##bind namespace=
-##bind script=script
-##bind subpath=traverse_subpath
-##parameters=
-##title=Ping information to Google
-##
-
-from Products.CMFCore.utils import getToolByName
-from Products.qPloneGoogleSitemaps.utils import ping_google
-
-url = getToolByName(context, 'portal_url')()
-
-portal_msg = "Google pinged. It will review your sitemap as soon as it will be able to."
-
-try:
-    ping_google(url)
-except:
-    portal_msg = "Cannot contact Google. Try again in a while."
-    
-return state.set(portal_status_message = portal_msg)
Index: loneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/ping_googlesitemaps.cpy.metadata
===================================================================
--- /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/ping_googlesitemaps.cpy.metadata	(revision 419)
+++ 	(revision )
@@ -1,13 +1,0 @@
-#
-# $$
-#
-[default]
-title=Google Sitemap Ping
-
-[security]
-View=0:Authenticated
-
-[validators]
-
-[actions]
-action.success=traverse_to:string:prefs_gsm_pinging
Index: /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_overview.cpt
===================================================================
--- /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_overview.cpt	(revision 419)
+++ /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_overview.cpt	(revision 420)
@@ -28,10 +28,4 @@
                   tal:attributes="href string: prefs_gsm_settings">
                   Settings</a>
-            </li>
-
-            <li class="">
-               <a href=""
-                  tal:attributes="href string: prefs_gsm_pinging"
-                  i18n:translate="label_logs">Pinging</a>
             </li>
 
Index: loneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_pinging.cpt
===================================================================
--- /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_pinging.cpt	(revision 419)
+++ 	(revision )
@@ -1,115 +1,0 @@
-<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-US"
-      xmlns:metal="http://xml.zope.org/namespaces/metal"
-      xmlns:tal="http://xml.zope.org/namespaces/tal"
-      lang="en-US"
-      metal:use-macro="here/prefs_main_template/macros/master"
-      i18n:domain="qPloneGoogleSitemaps"> 
-<body>
-    <div metal:fill-slot="prefs_configlet_main"
-        tal:define="errors python:request.get('errors', {})">
-
-        <div class="documentEditable">
-            <ul class="contentViews">
-                <li class="">
-                    <a href=""
-                    tal:attributes="href string: prefs_gsm_overview"
-                    i18n:translate="label_properties">Overview</a>
-                </li>
-
-                <li class="">
-                    <a href=""
-                    tal:attributes="href string:prefs_gsm_verification"
-                    i18n:translate="label_properties">Verification</a>
-                </li>
-
-                <li class="">
-                <a href=""
-                    tal:attributes="href string: prefs_gsm_settings">
-                    Settings</a>
-                </li>
-
-                <li class="selected">
-                <a href=""
-                    tal:attributes="href string: ${template/id}"
-                    i18n:translate="label_logs">Pinging</a>
-                </li>
-
-            </ul>
-
-            <div class="contentActions">
-            &nbsp;
-            </div>
-            <div class="documentContent">
-                <h1 i18n:translate="heading_plonegooglesitemaps">Plone Google Sitemaps</h1>
-                <a href=""
-                class="link-parent"
-                tal:attributes="href string: $portal_url/plone_control_panel"
-                i18n:translate="label_up_to_plone_setup">
-                Up to Plone Setup
-                </a>
-                <form>
-                    <fieldset>
-                        <legend>Google Ping</legend>
-                        <p>By pressing "Ping Google" button you inform Google that it
-                        should reread your sitemap as you did some modification on 
-                        the site. Google usually rereads your sitemap with it's 
-                        own schedule but you have possibility to hint it about best
-                        time to do that.</p>
-                        <div class="formControls">
-                            <input class="context"
-                                tabindex=""
-                                type="submit"
-                                name="form.button.Ping"
-                                value="Ping Google"
-                                i18n:attributes="value"
-                                tal:attributes="tabindex tabindex/next;" />
-                        </div>
-                    </fieldset>
-                    <div class="field"
-                         tal:define="portal_workflow portal/portal_workflow;
-                                     getWorkflowTransitions python:modules['Products.qPloneGoogleSitemaps.utils'].getWorkflowTransitions">
-                            <label for= "portal_workflow">
-                                        Workflows to ping
-                            </label>
-                            <div class="formHelp">
-                                        Transitions after which Google have been pinged
-                            </div>
-                            <fieldset class="workflow"
-                                      tal:repeat="workflow portal_workflow/listWorkflows">
-                                <legend tal:content="workflow">Workflow title (and id)</legend>
-                                <div class="field"
-                                    tal:repeat="transition python:getWorkflowTransitions(context,workflow)">
-                                <tal:transition define="enabled python:transition.after_script_name in ['', 'ping_googlesitemap'];
-                                    name string:${workflow}#${transition/id}">
-                                    <input type="checkbox"
-                                           name="transitions:list"
-                                           tal:attributes=" id name;
-                                                            value name;
-                                                            checked python:enabled and transition.after_script_name;
-                                                            disabled not:enabled"/>
-                                    <label tal:content="string:${transition/getId}: ${transition/title_or_id}"
-                                           tal:attributes="for name; class python:test(enabled, None, 'discreet')">Transition id
-                                    </label>
-                                    <span  class="discreet"
-                                            tal:condition="not:enabled"
-                                            tal:content="string:(${transition/after_script_name})" />
-                                </tal:transition>
-                            </div>
-                        </fieldset>
-                        <div class="formControls">
-                            <input class="context"
-                                tabindex=""
-                                type="submit"
-                                name="form.button.Save"
-                                value="Save"
-                                i18n:attributes="value"
-                                tal:attributes="tabindex tabindex/next;" />
-                        </div>
-                    </div>
-                    <input type="hidden" name="form.submitted" value="1" />
-                </form>
-            </div>
-        </div>
-    </div>
-</body>
-</html>
Index: loneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_pinging.cpt.metadata
===================================================================
--- /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_pinging.cpt.metadata	(revision 419)
+++ 	(revision )
@@ -1,15 +1,0 @@
-#
-# $$
-#
-[default]
-title=Plone Google Sitemap Configuration
-
-[security]
-View=0:Authenticated
-
-[validators]
-
-[actions]
-action.success..Ping=traverse_to:string:ping_googlesitemaps
-action.success..Save=traverse_to:string:gsm_edit_pinging
-action.failure=traverse_to:string:prefs_gsm_pinging
Index: /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_settings.cpt
===================================================================
--- /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_settings.cpt	(revision 419)
+++ /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_settings.cpt	(revision 420)
@@ -25,9 +25,4 @@
                    tal:attributes="href string:${template/id}">
                    Settings</a>
-                </li>
-                <li class="">
-                <a href=""
-                   tal:attributes="href string: prefs_gsm_pinging">
-                   Pinging</a>
                 </li>
             </ul>
Index: /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_verification.cpt
===================================================================
--- /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_verification.cpt	(revision 419)
+++ /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_verification.cpt	(revision 420)
@@ -28,10 +28,4 @@
                     tal:attributes="href string:prefs_gsm_settings">
                     Settings</a>
-                </li>
-
-                <li class="">
-                <a href=""
-                    tal:attributes="href string: prefs_gsm_pinging"
-                    i18n:translate="label_logs">Pinging</a>
                 </li>
 