Index: /qPloneGoogleSitemaps/branches/contenttype/browser/configletview.py
===================================================================
--- /qPloneGoogleSitemaps/branches/contenttype/browser/configletview.py	(revision 448)
+++ /qPloneGoogleSitemaps/branches/contenttype/browser/configletview.py	(revision 449)
@@ -27,8 +27,13 @@
     hasMobileSM = Attribute("Return boolean about existance mobile sitemap")
     hasNewsSM = Attribute("Return boolean about existance news sitemap")
+    sitemaps = Attribute("List of sitemap typs")
     sm_types = Attribute("List of sitemap typs")
 
-    def sitemapsDict(smtype):
+    def sitemapsDict():
         """ Return dictionary like object with data for table
+        """
+    def sitemapsURLByType():
+        """ Return dictionary like object with sitemap_type as key
+            and sitemap object(s) as value
         """
 
@@ -63,5 +68,22 @@
         return 'news' in self.sm_types
 
-    @property
+    def sitemapsURLByType(self):
+        sitemaps = {}
+        for sm in self.sitemaps:
+            smlist = sitemaps.setdefault(sm.getSitemapType(),[])
+            smlist.append({'url':sm.absolute_url(),'id':sm.id})
+        sitemaps['all'] = sitemaps.setdefault('content',[]) + \
+                          sitemaps.setdefault('mobile',[]) + \
+                          sitemaps.setdefault('news',[])
+        return sitemaps
+
+    def sitemapsURLs(self):
+        sitemaps = {}
+        for sm in self.sitemaps:
+            smlist = sitemaps.setdefault(sm.getSitemapType(),[])
+            smlist.append(sm.absolute_url())
+        return sitemaps
+
+
     def sitemapsDict(self):
         content, mobile, news = [],[],[]
Index: /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_overview.cpt
===================================================================
--- /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_overview.cpt	(revision 448)
+++ /qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_overview.cpt	(revision 449)
@@ -57,5 +57,7 @@
 
 <!--              -->
-            <dl>
+            <dl tal:define="view here/@@sitemap_settings;
+                            sitemaps view/sitemapsURLByType;
+                            all sitemaps/all | nothing">
             <dt>First step</dt>
             <dd>To enable Google Sitemaps on your site, add a sitemap at 
@@ -66,27 +68,23 @@
             </dd>
             <dt>Second step</dt>
-            <dd tal:define="gsm_prop here/portal_properties/googlesitemap_properties | nothing;
-                           content_sm gsm_prop/content_default | nothing;
-                           mobile_sm gsm_prop/mobile_default | nothing;
-                           news_sm gsm_prop/news_default | nothing;">
+            <dd>
+            <tal:condition-true condition="all">
             Your site is already Google Sitemaps enabled. Check 
+            <tal:loop repeat="smdata all">
             <a href="google-sitemaps"
-               tal:attributes="href string:$portal_url/$content_sm"
-               tal:condition="content_sm">content sitemap XML</a>
-            <span tal:replace="string:, "
-                  tal:condition="python:content_sm and (mobile_sm or news_sm)"/>
-            <a href="mobile-sitemaps"
-               tal:attributes="href string:$portal_url/$mobile_sm"
-               tal:condition="mobile_sm">mobile sitemap XML</a>
-            <span tal:replace="string:, "
-                  tal:condition="python:(content_sm or mobile_sm) and news_sm"/>
-            <a href="news-sitemaps"
-               tal:attributes="href string:$portal_url/$news_sm"
-               tal:condition="news_sm">news sitemap XML</a>
+               tal:attributes="href smdata/url"
+               tal:content="smdata/id">sitemap id</a>
+            <span tal:omit-tag=""
+                  tal:condition="not: repeat/smdata/end">,</span>
+            </tal:loop>
+            to see generated sitemap document(s) of your website. 
+            </tal:condition-true>
+            <tal:condition-false condition="not:all">
+            After adding Google Sitemap(s), check whether they where generated correctly.
+            </tal:condition-false>
 
-            to see generated sitemap document(s) of your website. They should contain URLs of 
-            all published objects. If you see something that should not be indexed by 
-            Google, retract objects or exclude sections with robots.txt (that GoogleBot 
-            obeys).
+            They should contain URLs of all published objects. If you see
+            something that should not be indexed by Google, retract objects or
+            exclude sections with robots.txt (that GoogleBot obeys).
             </dd>
             <dt>Third step</dt>
@@ -95,12 +93,20 @@
                 <li>go to <a href="https://www.google.com/webmasters/sitemaps">Google 
                 Sitemaps Central</a> (logging in / signing up as necessary)</li>
+                <tal:condition-true condition="all">
+
                 <li>add your sitemap URL(s): 
-                <code tal:content="string:$portal_url/google-sitemaps">http://example.com/google-sitemaps</code>
-                
-                <!!!!!!!>
-                <code tal:content="string:$portal_url/google-sitemaps">http://example.com/google-sitemaps</code>
-                <code tal:content="string:$portal_url/google-sitemaps">http://example.com/google-sitemaps</code>
-                </!!!!!!!>
-                
+                  <ul>
+                    <tal:loop repeat="smdata all">
+                    <li>
+                      <code tal:content="smdata/url">http://example.com/sitemaps.xml</code>
+                    </li>
+                    </tal:loop>
+                  </ul>
+                </tal:condition-true>
+
+                <tal:condition-false condition="not:all">
+                <li>This step will display urls to your sitemap(s) after adding it(them) in previous step(s)</li>
+                </tal:condition-false>
+
             </ol>
             It takes a while for your sitemap to be processed by Google. 
@@ -108,5 +114,5 @@
             submission to be processed instantly.
             </dd>
-            <dl>
+            </dl>
             <h2>Helpful resources</h2>
             <dl>