Index: qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/gsm_create_verify_file.cpy
===================================================================
--- qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/gsm_create_verify_file.cpy	(revision 449)
+++ qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/gsm_create_verify_file.cpy	(revision 450)
@@ -17,7 +17,9 @@
 except BadRequestException:
     pass
-props = getToolByName(context,'portal_properties').googlesitemap_properties
-props.manage_changeProperties(verification_filename = verify_filename)
-
+else:
+    props = getToolByName(context,'portal_properties').googlesitemap_properties
+    vfiles = list(props.getProperty('verification_filenames',[]))
+    vfiles.append(verify_filename)
+    props.manage_changeProperties(verification_filenames = vfiles)
 
 return state.set(portal_status_message = 'Plone Google Sitemap updated.')
Index: qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/gsm_delete_verify_file.cpy
===================================================================
--- qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/gsm_delete_verify_file.cpy	(revision 449)
+++ 	(revision )
@@ -1,23 +1,0 @@
-## Script (Python) "create_verify_file"
-##bind container=container
-##bind context=context
-##bind namespace=
-##bind script=script
-##bind subpath=traverse_subpath
-##parameters=
-##title=Create file for verification
-##
-
-from Products.CMFCore.utils import getToolByName
-props = getToolByName(context,'portal_properties').googlesitemap_properties
-
-portal = getToolByName(context,'portal_url').getPortalObject()
-try:
-    if portal[props.verification_filename].CreatedBy == 'qPloneGoogleSitemaps':
-        portal.manage_delObjects(props.verification_filename)
-except:
-    pass
-
-props.manage_changeProperties(verification_filename = '')
-
-return state.set(portal_status_message = 'Plone Google Sitemap updated.')
Index: qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/gsm_delete_verify_file.cpy.metadata
===================================================================
--- qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/gsm_delete_verify_file.cpy.metadata	(revision 449)
+++ 	(revision )
@@ -1,14 +1,0 @@
-#
-# $$
-#
-[default]
-title=Delete verify file
-
-[security]
-View=0:Authenticated
-
-[validators]
-
-[actions]
-action.success=traverse_to:string:prefs_gsm_verification
-action.failure=traverse_to:string:prefs_gsm_verification
Index: qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_verification.cpt
===================================================================
--- qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_verification.cpt	(revision 449)
+++ qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_verification.cpt	(revision 450)
@@ -8,5 +8,5 @@
     <div metal:fill-slot="prefs_configlet_main"
         tal:define="errors python:request.get('errors', {});
-                    props portal/portal_properties/googlesitemap_properties">
+                    view here/@@sitemap_settings;">
 
         <div class="documentEditable">
@@ -44,7 +44,7 @@
                 </a>
 
-                <form tal:define="file_provided props/verification_filename;
-                                  step1 python:test(file_provided, 'discreet', '');
-                                  step2 python:test(not file_provided, 'discreet', '')">
+                <form tal:define="vfiles view/getVerificationFiles;
+                                  step1 python:test(vfiles, 'discreet', '');
+                                  step2 python:test(not vfiles, 'discreet', '')">
                     <ol>
                         <li tal:attributes="class step1">
@@ -55,12 +55,8 @@
                         </li>
                         <li tal:attributes="class step1">Provide verification file name:
-                            <p><input name="verify_filename" id="verify_filename" type="text"
-                                tal:attributes="value props/verification_filename;
-                                                disabled step1"
-                            ></p>
+                            <p><input name="verify_filename" id="verify_filename" type="text"></p>
                         </li>
                         <li tal:attributes="class step1">
-                                <input name="form.button.CreateFile" id="create_file" type="submit" value="Create verification file"
-                                tal:attributes="disabled step1"/>
+                                <input name="form.button.CreateFile" id="create_file" type="submit" value="Create verification file"/>
                                 <input type="hidden" name="form.submitted" value="1" />
                         </li>
@@ -72,7 +68,10 @@
                         </li>
                         <li class="discreet"
-                            tal:attributes="class step2"><input name="form.button.DeleteFile" id="remove_file" type="submit" value="Remove verification file"
-                            tal:attributes="disabled step2;
-                                            value string:Remove ${file_provided} verifivation file"/>
+                            tal:attributes="class step2"
+                            tal:condition="vfiles">
+                            <strong>Existent verification files:</strong>
+                            <ul><li tal:repeat="vf vfiles"
+                                    tal:content="vf">verification file id
+                            </li></ul>
                         </li>
                     </ol>
Index: qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_verification.cpt.metadata
===================================================================
--- qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_verification.cpt.metadata	(revision 449)
+++ qPloneGoogleSitemaps/branches/contenttype/skins/qPloneGoogleSitemaps/prefs_gsm_verification.cpt.metadata	(revision 450)
@@ -12,4 +12,3 @@
 [actions]
 action.success..CreateFile=traverse_to:string:gsm_create_verify_file
-action.success..DeleteFile=traverse_to:string:gsm_delete_verify_file
 action.failure=traverse_to:string:prefs_gsm_verification